/**
 * QColor
 * by Daniel Steinbock <steinbock@stanford.edu>
 * 
 * Color utilities for QMovement
 *
 */ 

class QColor {
  
  color c;
  
  // heat map colors
  color myMap(float val) {
      float mid = .4;
      float vv;
      vv = abs(val);
      if(val < 0){
          val = mid - (mid * vv);
          
      }
      else {
          val = mid + ((1-mid) * vv);
          
      }
      float r=0;
      float b=0;
      float g=0;
      if(val < 0){
          val =0;
          
      }
      if(val > 1){
          val =1;
          
      }
      switch ((int)(val/.2)){
          case 0: r = 255;
          b = 0 + (255*((abs(val)%.2))/.2);
          g = 0;
          break;
          case 1: r = 255 - (255*((abs(val)%.2)/.2));
          b = 255;
          g = 0;
          break;
          case 2: r = 0;
          b = 255;
          g = 0 + (200*((abs(val)%.2)/.2));
          break;
          case 3: r = 100;
          b = 255 - (255*((abs(val)%.2)/.2));
          g = 150 + (105*((abs(val)%.2)/.2));
          break;
          case 4: r = 105 - (105*((abs(val)%.2))/.2);
          b = 0;
          g = 105 - (105*((abs(val)%.2))/.2);
          break;
          case 5: r = 0;
          b = 0;
          g = 25;
          break;
      }
      c = color(r, b, g);
      return c;
  }
}

