/**
 * QMovieController
 * by Daniel Steinbock <steinbock@stanford.edu>
 * 
 * Movie controller object for QMovement
 *
 */ 

import processing.video.*;
import codeanticode.gsvideo.*;

GSMovie mov;
int[] previousFrame;

class QMovieController {
  QMovieController(GSMovie theMovie) {
    mov = theMovie;
  }
  
  public void initMovie() {
    mov.read();
    int numPixels = mov.width * mov.height;
    movieLength = mov.length();
    mov.speed(0);
    mov.volume(0);
    println("MOVIE INIT\nw = " + mov.width + "\nh = " + mov.height + "\nL = " + movieLength);
    // Create an array to store the previously captured frame
    previousFrame = new int[numPixels];
    loadPixels();
    arraycopy(mov.pixels, previousFrame);
    println("loaded pixels " + (mov.width * mov.height));
//    selectionLoop = new PImage[int(movieLength / 1000) + 1];
//    selectionLoop[0] = get(0, 0, movie.width, movie.height);

//    // init selection box to whole mov
//    blankPixels = new int[mov.width * mov.height];        // creates blank pixels for masking non-selected areas
//    for(int i=0;i<mov.width * mov.height;++i){
//      blankPixels[i] = color(0,0,0); 
//    }   
  }
}
